#ifndef _CONFIGURATION_H_
#define _CONFIGURATION_H_
#define NO_PIN -1 // indikator nepouziteho pinu

#define VERSION "0.0.3"
#define SYSTEM_BUILD 3

#define __INOVERSION__ __FILE__ " Compiled @" __DATE__ " " __TIME__

#define DEBUG_BUILD // **** ladici varianta s Arduino OTA

#define HTTP_UPDATE // **** moznost aktualizace firmware pres www server pomoci http://%s.local/update
#define HTTP_UPDATE_USERNAME "admin" // **** uzivatelske jmeno pro update firmware (zapoznamkovanim teto definice vypneme nutnost prihlasovani)
#define HTTP_UPDATE_PASSWORD "nimda" // **** uzivatelske heslo pro update firmware

//#define USE_SPIFFS // **** podpora pro praci s SPIFFS souborovym systemem (webovy server dokaze servirovat stranky z SPIFFS)

#define FORCE_CONFIG_BUTTON_PIN NO_PIN // **** I/O pin, pouzity pro vynuceni konfigurace

#define LED_PIN 2//NO_PIN // pin, ke kteremu je pripojena LED dioda

#define HTTP_PORT 80 // port, na kterem pobezi HTTP (www) server

#ifdef DEBUG_BUILD
 #define STRINGIFY(x) #x
 #define TOSTRING(x) STRINGIFY(x)
 #include <trace.h>

 #define TRACE(severity, ...) trace_print(severity, __VA_ARGS__)
 #define TRACEFUNC(severity, ...) trace_printfunc(severity, __func__, __FILE__, TOSTRING(__LINE__), __VA_ARGS__)
 #define TRACEDUMP(severity, prefix, address, size) trace_dump(severity, prefix, address, size)
 #define TRACE_INIT trace_init()
 #define TRACE_ADDWEB(srv) trace_addweb(srv)
 #define TRACE_POLL trace_poll()
#else
 #define TRACE(...) ((void)0) // from assert.h "NOP" - http://stackoverflow.com/questions/9187628/c-empty-function-macros
 #define TRACEFUNC(...) ((void)0)
 #define TRACEDUMP(...) ((void)0)
 #define TRACE_INIT ((void)0)
 #define TRACE_ADDWEB(a) ((void)0)
 #define TRACE_POLL ((void)0)
#endif

#define BUFFERSIZE 128 // velikost vyrovnavaciho bufferu

#define VCP_PORT 5555 // cislo pouziteho portu

#define NVT_TX_MAXSIZE 64

#define TX_TIMEOUT_MULTIPLIER 3

#define TX_TIMEOUT_DIVISOR 2

//#define RX_BUFFER_SIZE 4096 // velikost prijimaciho bufferu pro seriovy port v pripade, ze Core uz podporuje nastaveni velikosti (v soucasne dobe pouze github verze...)

#define INITIAL_SERIAL_SPEED 9600 // pocatecni prenosova rychlost

#define EEPROM_MAGIC 0xaabbccdc

#ifdef USE_CRASHDUMP
 #define SAVE_CRASH_SPACE_SIZE       0x0200  // space reserved to store crash data
 #define SAVE_CRASH_EEPROM_OFFSET (EEPROM_CONFIG_ORIGIN + offsetof(eepromconfig_t, sc))
#endif

#define EEPROM_SIZE (sizeof(wificonfigarea_t) + sizeof(eepromconfig_t) + 10) // velikost EEPROM oblasti (POZOR!!! zbytecnym zvetsovanim se zaroven zmensuje velikost RAM kvuli zrcadlu!!!)

#define EEPROM_WIFICONFIG_ORIGIN (EEPROM_SIZE - sizeof(wificonfigarea_t)) // pocatek oblasti, pouzivane WiFiConfig

#define EEPROM_CONFIG_ORIGIN (0)

#define CORS_DEBUG

#endif
